#!/usr/bin/perl

# mir2konn_xml.pl - konwerter formatu historii Miranda do Konnekt
# 2010-07-25, v1.0 Sz.Fijal :: sjf

use strict;

die "** Podaj plik do konwersji\n" if @ARGV == 0;
open IN,'<',$ARGV[0] or die "** Blad odczytu pliku: \"$ARGV[0]\": $!\n";

my ($sec,$min,$hour,$day,$mon,$year) = (localtime)[0..5];
my $curr_date = sprintf "%02d-%02d-%4d", $day,$mon+1,$year+1900;
my $curr_time = sprintf "%02d:%02d", $hour,$min;

# Preambula pliku wyjsciowego
print <<"EOF";
<?xml version="1.0" encoding="Windows-1250"?>
<?xml-stylesheet type="text/xsl" href="D:\\apps\\Konnekt\\data\\history\\exported renderer.xsl"?>
<history>
    <info>
        <date>$curr_date $curr_time</date>
        <profile>exported</profile>
    </info>
EOF

my $first_message = 1;
my $prev_date = "??";
my ($date,$time,$name, $time_sh, $message);
my ($name1,$proto1,$id1, $name2,$proto2,$id2, $netid);
my $line = 0;
while(<IN>){
    chomp;
    next if /^\s*$/;

    # Naglowek eksportu Mirandy
    if (/^#/) {
        if (/^#+ +([\w \.,]+) +\((\S+): +(\S+)\)[ \-]+([\w \.,]+) +\((\S+): +(\S+)\)/) {
            ($name1,$proto1,$id1, $name2,$proto2,$id2) = /^#+ +([\w \.,]+) +\((\S+): +(\S+)\)[ \-]+([\w \.,]+) +\((\S+): +(\S+)\)/;
            if    ($proto2 =~ /^GG$/i)     { $netid = 10; }
            elsif ($proto2 =~ /^TLEN$/i)   { $netid = 63; }
            elsif ($proto2 =~ /^JABBER$/i) { $netid = 12; }
            else {
                $netid = 0;
                die "** Nieobsugiwana sie \"$proto2\"\n";
            }
            warn "## name1: $name1 = $proto1:$id1,  name2: $name2 = $proto2:$id2\n";
            print "    <contact name=\"$name2\" info=\"\">\n";
        }
        next;
    }

    if (/^\[.+\] +.+\s*$/) {
        $line = 0;
        # Odczyt date, time i zmiana formatu date (w Mirandzie jest yyyy-mm-dd,
        # w Konnekcie - dd-mm-yyyy)
        ($date,$time,$name) = /^\[(\S+) +(\S+)\] +([^:]+)/;
        if ($date=~/(\d{4})\-(\d{2})\-(\d{2})/) { $date = "$3-$2-$1" }

        print "</message>\n" if ! $first_message;

        # Gdy "nowy dzien" to nowy chat :)
        if ($date != $prev_date) {
            print "        </chat>\n" if ! $first_message;
            print "        <chat date=\"$date\" time=\"$time\">\n";
        }

        if ($name eq $name1) {
            print "            <message name=\"$name1\"  date=\"$date\" time=\"$time\"  net=\"$netid\"  type=\"1\"  flag=\"2\"  fromUid=\"$id1\"  toUid=\"$id2\"  ext=\"\" >";
        }
        elsif ($name eq $name2) {
            print "            <message name=\"$name2\"  date=\"$date\" time=\"$time\"  net=\"$netid\"  type=\"1\"  flag=\"128\"  fromUid=\"$id2\"  toUid=\"$id1\"  ext=\"\" >";
        }
        else {
            warn "## name ($name) \!\= name1 ($name1) and name2 ($name2) - bledny rekord ($_)\n";
        }

        if ($first_message) { $first_message = 0; }
        $prev_date = $date;
    }
    # Tresc wiadomosci
    else {
        if ($line==0) { print $_; } else { print "\n$_"; }
        $line++;
    }
}
print <<"EOF";
</message>
        </chat>
    </contact>
</history>
EOF
